#include "csystem.h"
#include "rtsc_annotate.h"

#include <stdatomic.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include <time.h>
#include <unistd.h>

DeclareSubtask(TaskTask0Job1);
DeclareSubtask(TaskTask0Job2);
DeclareSubtask(TaskTask0Job3);
DeclareSubtask(TaskTask0Job4);
DeclareSubtask(TaskTask1Job1);
DeclareSubtask(TaskTask1Job2);
DeclareSubtask(TaskTask1Job3);
DeclareSubtask(TaskTask1Job4);
DeclareSubtask(TaskTask10Job1);
DeclareSubtask(TaskTask10Job2);
DeclareSubtask(TaskTask10Job3);
DeclareSubtask(TaskTask10Job4);
DeclareSubtask(TaskTask11Job1);
DeclareSubtask(TaskTask11Job2);
DeclareSubtask(TaskTask11Job3);
DeclareSubtask(TaskTask11Job4);
DeclareSubtask(TaskTask2Job1);
DeclareSubtask(TaskTask3Job1);
DeclareSubtask(TaskTask3Job2);
DeclareSubtask(TaskTask4Job1);
DeclareSubtask(TaskTask4Job2);
DeclareSubtask(TaskTask4Job3);
DeclareSubtask(TaskTask4Job4);
DeclareSubtask(TaskTask4Job5);
DeclareSubtask(TaskTask4Job6);
DeclareSubtask(TaskTask4Job7);
DeclareSubtask(TaskTask4Job8);
DeclareSubtask(TaskTask4Job9);
DeclareSubtask(TaskTask4Job10);
DeclareSubtask(TaskTask4Job11);
DeclareSubtask(TaskTask4Job12);
DeclareSubtask(TaskTask4Job13);
DeclareSubtask(TaskTask4Job14);
DeclareSubtask(TaskTask4Job15);
DeclareSubtask(TaskTask4Job16);
DeclareSubtask(TaskTask4Job17);
DeclareSubtask(TaskTask4Job18);
DeclareSubtask(TaskTask4Job19);
DeclareSubtask(TaskTask4Job20);
DeclareSubtask(TaskTask5Job1);
DeclareSubtask(TaskTask5Job2);
DeclareSubtask(TaskTask6Job1);
DeclareSubtask(TaskTask6Job2);
DeclareSubtask(TaskTask6Job3);
DeclareSubtask(TaskTask6Job4);
DeclareSubtask(TaskTask6Job5);
DeclareSubtask(TaskTask6Job6);
DeclareSubtask(TaskTask6Job7);
DeclareSubtask(TaskTask6Job8);
DeclareSubtask(TaskTask6Job9);
DeclareSubtask(TaskTask6Job10);
DeclareSubtask(TaskTask6Job11);
DeclareSubtask(TaskTask6Job12);
DeclareSubtask(TaskTask6Job13);
DeclareSubtask(TaskTask6Job14);
DeclareSubtask(TaskTask6Job15);
DeclareSubtask(TaskTask6Job16);
DeclareSubtask(TaskTask6Job17);
DeclareSubtask(TaskTask6Job18);
DeclareSubtask(TaskTask6Job19);
DeclareSubtask(TaskTask6Job20);
DeclareSubtask(TaskTask7Job1);
DeclareSubtask(TaskTask7Job2);
DeclareSubtask(TaskTask7Job3);
DeclareSubtask(TaskTask7Job4);
DeclareSubtask(TaskTask7Job5);
DeclareSubtask(TaskTask7Job6);
DeclareSubtask(TaskTask7Job7);
DeclareSubtask(TaskTask7Job8);
DeclareSubtask(TaskTask7Job9);
DeclareSubtask(TaskTask7Job10);
DeclareSubtask(TaskTask7Job11);
DeclareSubtask(TaskTask7Job12);
DeclareSubtask(TaskTask7Job13);
DeclareSubtask(TaskTask7Job14);
DeclareSubtask(TaskTask7Job15);
DeclareSubtask(TaskTask7Job16);
DeclareSubtask(TaskTask7Job17);
DeclareSubtask(TaskTask7Job18);
DeclareSubtask(TaskTask7Job19);
DeclareSubtask(TaskTask7Job20);
DeclareSubtask(TaskTask8Job1);
DeclareSubtask(TaskTask8Job2);
DeclareSubtask(TaskTask8Job3);
DeclareSubtask(TaskTask8Job4);
DeclareSubtask(TaskTask8Job5);
DeclareSubtask(TaskTask8Job6);
DeclareSubtask(TaskTask8Job7);
DeclareSubtask(TaskTask8Job8);
DeclareSubtask(TaskTask8Job9);
DeclareSubtask(TaskTask8Job10);
DeclareSubtask(TaskTask8Job11);
DeclareSubtask(TaskTask8Job12);
DeclareSubtask(TaskTask8Job13);
DeclareSubtask(TaskTask8Job14);
DeclareSubtask(TaskTask8Job15);
DeclareSubtask(TaskTask8Job16);
DeclareSubtask(TaskTask8Job17);
DeclareSubtask(TaskTask8Job18);
DeclareSubtask(TaskTask8Job19);
DeclareSubtask(TaskTask8Job20);
DeclareSubtask(TaskTask9Job1);
DeclareSubtask(TaskTask9Job2);
DeclareSubtask(TaskTask9Job3);
DeclareSubtask(TaskTask9Job4);
DeclareSubtask(TaskTask9Job5);
DeclareSubtask(TaskTask9Job6);
DeclareSubtask(TaskTask9Job7);
DeclareSubtask(TaskTask9Job8);
DeclareSubtask(TaskTask9Job9);
DeclareSubtask(TaskTask9Job10);





static const int NUMS = 4096;
static const int SECONDS_TO_NANO = 1000000000;
static const int MICROSECONDS_TO_NANO = 1000;
static int num[4096];
typedef struct timespec Time;

typedef struct data {
	uint64_t val;
	Time ts;
} data;
typedef _Atomic data atomic_data;

//Provided by data/SystemSupport/Litmus/misc/randomArray.cpp
double getNextRandom(void);

void logDataAge(unsigned int chain, unsigned int instance, unsigned long dataAge );

static atomic_data Task0_Chain_0;
size_t getMaxChainInstances(void) {

	return 4;

}

static Time get_time() {
	RTSC_setBBWCET(0);
	static Time t;
	int err;
	err = clock_gettime(CLOCK_MONOTONIC, &t);
	if (err != 0) {
		RTSC_setBBWCET(0);
		perror("get_time():");
	}
	RTSC_setBBWCET(0);
	return t;
}

static inline Time time_diff(Time oldTime, Time time) {
	RTSC_setBBWCET(0);
	if (time.tv_nsec < oldTime.tv_nsec) {
		RTSC_setBBWCET(0);
		return (Time){
			.tv_sec = time.tv_sec - 1 - oldTime.tv_sec,
			.tv_nsec = 1000000000UL + time.tv_nsec - oldTime.tv_nsec
		};
	}
	else {
		RTSC_setBBWCET(0);
		return (Time){
			.tv_sec = time.tv_sec - oldTime.tv_sec,
			.tv_nsec = time.tv_nsec - oldTime.tv_nsec
		};
	}
	RTSC_setBBWCET(0);
}
static long time_to_longNS(Time ts) {
	RTSC_setBBWCET(0);
	return (ts.tv_sec * SECONDS_TO_NANO + ts.tv_nsec);
}

static long cputime(void) {
	RTSC_setBBWCET(0);
	Time ts;
	int err;
	err = clock_gettime(CLOCK_THREAD_CPUTIME_ID, &ts);
	if (err != 0) {
		RTSC_setBBWCET(0);
		perror("cputime");
	}
	RTSC_setBBWCET(0);
	return (ts.tv_sec * SECONDS_TO_NANO + ts.tv_nsec);
}

static long wctime(void) {
	RTSC_setBBWCET(0);
	struct timeval tv;
	gettimeofday(&tv, NULL);
	return (tv.tv_sec * SECONDS_TO_NANO + tv.tv_usec * MICROSECONDS_TO_NANO);
}

static int loop_once(void) {
	RTSC_setBBWCET(0);
	int i;
	int j = 0;
	for (i = 0; i < NUMS; i++) {
		RTSC_setLoopCount(0);
		RTSC_setBBWCET(0);
		j += num[i]++;
		if (j > num[i]) {
			RTSC_setBBWCET(0);
			num[i] = (j / 2) + 1;
		}
	}
	RTSC_setBBWCET(0);
	return j;
}

static int loop_for(long exec_time, long emergency_exit) {
	RTSC_setBBWCET(0);
	long full_exec_time = exec_time;
	exec_time = getNextRandom() * exec_time;
	long last_loop = 0;
	int tmp = 0;

	long start = cputime();
	long now = start;

	while (now + 3 * last_loop < start + exec_time) {
		RTSC_setLoopCount(0);
		RTSC_setBBWCET(0);
		long loop_start = now;
		tmp += loop_once();
		now = cputime();
		last_loop = now - loop_start;
		if (emergency_exit && wctime() > emergency_exit) {
			RTSC_setBBWCET(0);
			fprintf(stderr, "!!! rtspin/%d emergency exit!\n", getpid());
			fprintf(stderr, "Something is seriously wrong! Do not ignore this.\n");
			break;
		}
	}
	RTSC_setBBWCET(0);
	logLoopFor(full_exec_time, exec_time, now - start);
	return tmp;
}

Subtask(TaskTask0Job1) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(122595,0);
	RTSC_setBBWCET(122595);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask0Job2) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(122595,0);
	RTSC_setBBWCET(122595);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask0Job3) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(122595,0);
	RTSC_setBBWCET(122595);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask0Job4) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(122595,0);
	RTSC_setBBWCET(122595);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job1) {





	loop_for(134240,0);
	RTSC_setBBWCET(134240);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job2) {





	loop_for(134240,0);
	RTSC_setBBWCET(134240);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job3) {





	loop_for(134240,0);
	RTSC_setBBWCET(134240);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job4) {





	loop_for(134240,0);
	RTSC_setBBWCET(134240);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask10Job1) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(51247,0);
	RTSC_setBBWCET(51247);


	logDataAge(0,1, time_to_longNS(time_diff(Chain_0.ts, get_time())));

	RTSC_setBBWCET(0);

}


Subtask(TaskTask10Job2) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(51247,0);
	RTSC_setBBWCET(51247);


	logDataAge(0,2, time_to_longNS(time_diff(Chain_0.ts, get_time())));

	RTSC_setBBWCET(0);

}


Subtask(TaskTask10Job3) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(51247,0);
	RTSC_setBBWCET(51247);


	logDataAge(0,3, time_to_longNS(time_diff(Chain_0.ts, get_time())));

	RTSC_setBBWCET(0);

}


Subtask(TaskTask10Job4) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(51247,0);
	RTSC_setBBWCET(51247);


	logDataAge(0,4, time_to_longNS(time_diff(Chain_0.ts, get_time())));

	RTSC_setBBWCET(0);

}


Subtask(TaskTask11Job1) {





	loop_for(50990,0);
	RTSC_setBBWCET(50990);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask11Job2) {





	loop_for(50990,0);
	RTSC_setBBWCET(50990);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask11Job3) {





	loop_for(50990,0);
	RTSC_setBBWCET(50990);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask11Job4) {





	loop_for(50990,0);
	RTSC_setBBWCET(50990);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask2Job1) {





	loop_for(60986,0);
	RTSC_setBBWCET(60986);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask3Job1) {





	loop_for(55440,0);
	RTSC_setBBWCET(55440);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask3Job2) {





	loop_for(55440,0);
	RTSC_setBBWCET(55440);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job1) {





	loop_for(134702,0);
	RTSC_setBBWCET(134702);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job2) {





	loop_for(134702,0);
	RTSC_setBBWCET(134702);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job3) {





	loop_for(134702,0);
	RTSC_setBBWCET(134702);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job4) {





	loop_for(134702,0);
	RTSC_setBBWCET(134702);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job5) {





	loop_for(134702,0);
	RTSC_setBBWCET(134702);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job6) {





	loop_for(134702,0);
	RTSC_setBBWCET(134702);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job7) {





	loop_for(134702,0);
	RTSC_setBBWCET(134702);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job8) {





	loop_for(134702,0);
	RTSC_setBBWCET(134702);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job9) {





	loop_for(134702,0);
	RTSC_setBBWCET(134702);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job10) {





	loop_for(134702,0);
	RTSC_setBBWCET(134702);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job11) {





	loop_for(134702,0);
	RTSC_setBBWCET(134702);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job12) {





	loop_for(134702,0);
	RTSC_setBBWCET(134702);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job13) {





	loop_for(134702,0);
	RTSC_setBBWCET(134702);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job14) {





	loop_for(134702,0);
	RTSC_setBBWCET(134702);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job15) {





	loop_for(134702,0);
	RTSC_setBBWCET(134702);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job16) {





	loop_for(134702,0);
	RTSC_setBBWCET(134702);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job17) {





	loop_for(134702,0);
	RTSC_setBBWCET(134702);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job18) {





	loop_for(134702,0);
	RTSC_setBBWCET(134702);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job19) {





	loop_for(134702,0);
	RTSC_setBBWCET(134702);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job20) {





	loop_for(134702,0);
	RTSC_setBBWCET(134702);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask5Job1) {





	loop_for(70486,0);
	RTSC_setBBWCET(70486);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask5Job2) {





	loop_for(70486,0);
	RTSC_setBBWCET(70486);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job1) {





	loop_for(143370,0);
	RTSC_setBBWCET(143370);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job2) {





	loop_for(143370,0);
	RTSC_setBBWCET(143370);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job3) {





	loop_for(143370,0);
	RTSC_setBBWCET(143370);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job4) {





	loop_for(143370,0);
	RTSC_setBBWCET(143370);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job5) {





	loop_for(143370,0);
	RTSC_setBBWCET(143370);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job6) {





	loop_for(143370,0);
	RTSC_setBBWCET(143370);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job7) {





	loop_for(143370,0);
	RTSC_setBBWCET(143370);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job8) {





	loop_for(143370,0);
	RTSC_setBBWCET(143370);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job9) {





	loop_for(143370,0);
	RTSC_setBBWCET(143370);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job10) {





	loop_for(143370,0);
	RTSC_setBBWCET(143370);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job11) {





	loop_for(143370,0);
	RTSC_setBBWCET(143370);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job12) {





	loop_for(143370,0);
	RTSC_setBBWCET(143370);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job13) {





	loop_for(143370,0);
	RTSC_setBBWCET(143370);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job14) {





	loop_for(143370,0);
	RTSC_setBBWCET(143370);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job15) {





	loop_for(143370,0);
	RTSC_setBBWCET(143370);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job16) {





	loop_for(143370,0);
	RTSC_setBBWCET(143370);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job17) {





	loop_for(143370,0);
	RTSC_setBBWCET(143370);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job18) {





	loop_for(143370,0);
	RTSC_setBBWCET(143370);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job19) {





	loop_for(143370,0);
	RTSC_setBBWCET(143370);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job20) {





	loop_for(143370,0);
	RTSC_setBBWCET(143370);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job1) {





	loop_for(142581,0);
	RTSC_setBBWCET(142581);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job2) {





	loop_for(142581,0);
	RTSC_setBBWCET(142581);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job3) {





	loop_for(142581,0);
	RTSC_setBBWCET(142581);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job4) {





	loop_for(142581,0);
	RTSC_setBBWCET(142581);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job5) {





	loop_for(142581,0);
	RTSC_setBBWCET(142581);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job6) {





	loop_for(142581,0);
	RTSC_setBBWCET(142581);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job7) {





	loop_for(142581,0);
	RTSC_setBBWCET(142581);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job8) {





	loop_for(142581,0);
	RTSC_setBBWCET(142581);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job9) {





	loop_for(142581,0);
	RTSC_setBBWCET(142581);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job10) {





	loop_for(142581,0);
	RTSC_setBBWCET(142581);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job11) {





	loop_for(142581,0);
	RTSC_setBBWCET(142581);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job12) {





	loop_for(142581,0);
	RTSC_setBBWCET(142581);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job13) {





	loop_for(142581,0);
	RTSC_setBBWCET(142581);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job14) {





	loop_for(142581,0);
	RTSC_setBBWCET(142581);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job15) {





	loop_for(142581,0);
	RTSC_setBBWCET(142581);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job16) {





	loop_for(142581,0);
	RTSC_setBBWCET(142581);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job17) {





	loop_for(142581,0);
	RTSC_setBBWCET(142581);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job18) {





	loop_for(142581,0);
	RTSC_setBBWCET(142581);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job19) {





	loop_for(142581,0);
	RTSC_setBBWCET(142581);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job20) {





	loop_for(142581,0);
	RTSC_setBBWCET(142581);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job1) {





	loop_for(57888,0);
	RTSC_setBBWCET(57888);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job2) {





	loop_for(57888,0);
	RTSC_setBBWCET(57888);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job3) {





	loop_for(57888,0);
	RTSC_setBBWCET(57888);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job4) {





	loop_for(57888,0);
	RTSC_setBBWCET(57888);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job5) {





	loop_for(57888,0);
	RTSC_setBBWCET(57888);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job6) {





	loop_for(57888,0);
	RTSC_setBBWCET(57888);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job7) {





	loop_for(57888,0);
	RTSC_setBBWCET(57888);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job8) {





	loop_for(57888,0);
	RTSC_setBBWCET(57888);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job9) {





	loop_for(57888,0);
	RTSC_setBBWCET(57888);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job10) {





	loop_for(57888,0);
	RTSC_setBBWCET(57888);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job11) {





	loop_for(57888,0);
	RTSC_setBBWCET(57888);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job12) {





	loop_for(57888,0);
	RTSC_setBBWCET(57888);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job13) {





	loop_for(57888,0);
	RTSC_setBBWCET(57888);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job14) {





	loop_for(57888,0);
	RTSC_setBBWCET(57888);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job15) {





	loop_for(57888,0);
	RTSC_setBBWCET(57888);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job16) {





	loop_for(57888,0);
	RTSC_setBBWCET(57888);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job17) {





	loop_for(57888,0);
	RTSC_setBBWCET(57888);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job18) {





	loop_for(57888,0);
	RTSC_setBBWCET(57888);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job19) {





	loop_for(57888,0);
	RTSC_setBBWCET(57888);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job20) {





	loop_for(57888,0);
	RTSC_setBBWCET(57888);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask9Job1) {





	loop_for(64407,0);
	RTSC_setBBWCET(64407);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask9Job2) {





	loop_for(64407,0);
	RTSC_setBBWCET(64407);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask9Job3) {





	loop_for(64407,0);
	RTSC_setBBWCET(64407);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask9Job4) {





	loop_for(64407,0);
	RTSC_setBBWCET(64407);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask9Job5) {





	loop_for(64407,0);
	RTSC_setBBWCET(64407);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask9Job6) {





	loop_for(64407,0);
	RTSC_setBBWCET(64407);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask9Job7) {





	loop_for(64407,0);
	RTSC_setBBWCET(64407);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask9Job8) {





	loop_for(64407,0);
	RTSC_setBBWCET(64407);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask9Job9) {





	loop_for(64407,0);
	RTSC_setBBWCET(64407);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask9Job10) {





	loop_for(64407,0);
	RTSC_setBBWCET(64407);



	RTSC_setBBWCET(0);

}


