#include "csystem.h"
#include "rtsc_annotate.h"

#include <stdatomic.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include <time.h>
#include <unistd.h>

DeclareSubtask(TaskTask0Job1);
DeclareSubtask(TaskTask0Job2);
DeclareSubtask(TaskTask0Job3);
DeclareSubtask(TaskTask0Job4);
DeclareSubtask(TaskTask0Job5);
DeclareSubtask(TaskTask0Job6);
DeclareSubtask(TaskTask0Job7);
DeclareSubtask(TaskTask0Job8);
DeclareSubtask(TaskTask0Job9);
DeclareSubtask(TaskTask0Job10);
DeclareSubtask(TaskTask1Job1);
DeclareSubtask(TaskTask1Job2);
DeclareSubtask(TaskTask1Job3);
DeclareSubtask(TaskTask1Job4);
DeclareSubtask(TaskTask1Job5);
DeclareSubtask(TaskTask1Job6);
DeclareSubtask(TaskTask1Job7);
DeclareSubtask(TaskTask1Job8);
DeclareSubtask(TaskTask1Job9);
DeclareSubtask(TaskTask1Job10);
DeclareSubtask(TaskTask10Job1);
DeclareSubtask(TaskTask11Job1);
DeclareSubtask(TaskTask12Job1);
DeclareSubtask(TaskTask13Job1);
DeclareSubtask(TaskTask13Job2);
DeclareSubtask(TaskTask13Job3);
DeclareSubtask(TaskTask13Job4);
DeclareSubtask(TaskTask13Job5);
DeclareSubtask(TaskTask2Job1);
DeclareSubtask(TaskTask2Job2);
DeclareSubtask(TaskTask2Job3);
DeclareSubtask(TaskTask2Job4);
DeclareSubtask(TaskTask2Job5);
DeclareSubtask(TaskTask2Job6);
DeclareSubtask(TaskTask2Job7);
DeclareSubtask(TaskTask2Job8);
DeclareSubtask(TaskTask2Job9);
DeclareSubtask(TaskTask2Job10);
DeclareSubtask(TaskTask3Job1);
DeclareSubtask(TaskTask3Job2);
DeclareSubtask(TaskTask3Job3);
DeclareSubtask(TaskTask3Job4);
DeclareSubtask(TaskTask3Job5);
DeclareSubtask(TaskTask3Job6);
DeclareSubtask(TaskTask3Job7);
DeclareSubtask(TaskTask3Job8);
DeclareSubtask(TaskTask3Job9);
DeclareSubtask(TaskTask3Job10);
DeclareSubtask(TaskTask4Job1);
DeclareSubtask(TaskTask4Job2);
DeclareSubtask(TaskTask4Job3);
DeclareSubtask(TaskTask4Job4);
DeclareSubtask(TaskTask4Job5);
DeclareSubtask(TaskTask5Job1);
DeclareSubtask(TaskTask5Job2);
DeclareSubtask(TaskTask5Job3);
DeclareSubtask(TaskTask5Job4);
DeclareSubtask(TaskTask5Job5);
DeclareSubtask(TaskTask6Job1);
DeclareSubtask(TaskTask6Job2);
DeclareSubtask(TaskTask6Job3);
DeclareSubtask(TaskTask6Job4);
DeclareSubtask(TaskTask6Job5);
DeclareSubtask(TaskTask7Job1);
DeclareSubtask(TaskTask7Job2);
DeclareSubtask(TaskTask7Job3);
DeclareSubtask(TaskTask7Job4);
DeclareSubtask(TaskTask7Job5);
DeclareSubtask(TaskTask8Job1);
DeclareSubtask(TaskTask9Job1);



DeclareEvent(TaskTask9Job1TaskTask10Job1Event);
DeclareEvent(TaskTask10Job1TaskTask12Job1Event);
DeclareEvent(TaskTask7Job1TaskTask13Job1Event);
DeclareEvent(TaskTask7Job2TaskTask13Job2Event);
DeclareEvent(TaskTask7Job3TaskTask13Job3Event);
DeclareEvent(TaskTask7Job4TaskTask13Job4Event);
DeclareEvent(TaskTask7Job5TaskTask13Job5Event);
DeclareEvent(TaskTask12Job1TaskTask5Job2Event);
DeclareEvent(TaskTask5Job1TaskTask6Job1Event);
DeclareEvent(TaskTask5Job2TaskTask6Job2Event);
DeclareEvent(TaskTask5Job3TaskTask6Job3Event);
DeclareEvent(TaskTask5Job4TaskTask6Job4Event);
DeclareEvent(TaskTask5Job5TaskTask6Job5Event);
DeclareEvent(TaskTask6Job1TaskTask7Job1Event);
DeclareEvent(TaskTask6Job2TaskTask7Job2Event);
DeclareEvent(TaskTask6Job3TaskTask7Job3Event);
DeclareEvent(TaskTask6Job4TaskTask7Job4Event);
DeclareEvent(TaskTask6Job5TaskTask7Job5Event);
DeclareEvent(TaskTask8Job1TaskTask9Job1Event);


static const int NUMS = 4096;
static const int SECONDS_TO_NANO = 1000000000;
static const int MICROSECONDS_TO_NANO = 1000;
static int num[4096];
typedef struct timespec Time;

typedef struct data {
	uint64_t val;
	Time ts;
} data;
typedef _Atomic data atomic_data;

//Provided by data/SystemSupport/Litmus/misc/randomArray.cpp
double getNextRandom(void);

void logDataAge(unsigned int chain, unsigned int instance, unsigned long dataAge );

static atomic_data Task0_Chain_0;
static atomic_data Task1_Chain_0;
static atomic_data Task2_Chain_0;
static atomic_data Task3_Chain_0;
static atomic_data Task8_Chain_0;
static atomic_data Task9_Chain_0;
static atomic_data Task10_Chain_0;
static atomic_data Task12_Chain_0;
static atomic_data Task5_Chain_0;
static atomic_data Task6_Chain_0;
static atomic_data Task7_Chain_0;
size_t getMaxChainInstances(void) {

	return 5;

}

static Time get_time() {
	RTSC_setBBWCET(0);
	static Time t;
	int err;
	err = clock_gettime(CLOCK_MONOTONIC, &t);
	if (err != 0) {
		RTSC_setBBWCET(0);
		perror("get_time():");
	}
	RTSC_setBBWCET(0);
	return t;
}

static inline Time time_diff(Time oldTime, Time time) {
	RTSC_setBBWCET(0);
	if (time.tv_nsec < oldTime.tv_nsec) {
		RTSC_setBBWCET(0);
		return (Time){
			.tv_sec = time.tv_sec - 1 - oldTime.tv_sec,
			.tv_nsec = 1000000000UL + time.tv_nsec - oldTime.tv_nsec
		};
	}
	else {
		RTSC_setBBWCET(0);
		return (Time){
			.tv_sec = time.tv_sec - oldTime.tv_sec,
			.tv_nsec = time.tv_nsec - oldTime.tv_nsec
		};
	}
	RTSC_setBBWCET(0);
}
static long time_to_longNS(Time ts) {
	RTSC_setBBWCET(0);
	return (ts.tv_sec * SECONDS_TO_NANO + ts.tv_nsec);
}

static long cputime(void) {
	RTSC_setBBWCET(0);
	Time ts;
	int err;
	err = clock_gettime(CLOCK_THREAD_CPUTIME_ID, &ts);
	if (err != 0) {
		RTSC_setBBWCET(0);
		perror("cputime");
	}
	RTSC_setBBWCET(0);
	return (ts.tv_sec * SECONDS_TO_NANO + ts.tv_nsec);
}

static long wctime(void) {
	RTSC_setBBWCET(0);
	struct timeval tv;
	gettimeofday(&tv, NULL);
	return (tv.tv_sec * SECONDS_TO_NANO + tv.tv_usec * MICROSECONDS_TO_NANO);
}

static int loop_once(void) {
	RTSC_setBBWCET(0);
	int i;
	int j = 0;
	for (i = 0; i < NUMS; i++) {
		RTSC_setLoopCount(0);
		RTSC_setBBWCET(0);
		j += num[i]++;
		if (j > num[i]) {
			RTSC_setBBWCET(0);
			num[i] = (j / 2) + 1;
		}
	}
	RTSC_setBBWCET(0);
	return j;
}

static int loop_for(long exec_time, long emergency_exit) {
	RTSC_setBBWCET(0);
	long full_exec_time = exec_time;
	exec_time = getNextRandom() * exec_time;
	long last_loop = 0;
	int tmp = 0;

	long start = cputime();
	long now = start;

	while (now + 3 * last_loop < start + exec_time) {
		RTSC_setLoopCount(0);
		RTSC_setBBWCET(0);
		long loop_start = now;
		tmp += loop_once();
		now = cputime();
		last_loop = now - loop_start;
		if (emergency_exit && wctime() > emergency_exit) {
			RTSC_setBBWCET(0);
			fprintf(stderr, "!!! rtspin/%d emergency exit!\n", getpid());
			fprintf(stderr, "Something is seriously wrong! Do not ignore this.\n");
			break;
		}
	}
	RTSC_setBBWCET(0);
	logLoopFor(full_exec_time, exec_time, now - start);
	return tmp;
}

Subtask(TaskTask0Job1) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(149403,0);
	RTSC_setBBWCET(149403);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask0Job2) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(149403,0);
	RTSC_setBBWCET(149403);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask0Job3) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(149403,0);
	RTSC_setBBWCET(149403);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask0Job4) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(149403,0);
	RTSC_setBBWCET(149403);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask0Job5) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(149403,0);
	RTSC_setBBWCET(149403);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask0Job6) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(149403,0);
	RTSC_setBBWCET(149403);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask0Job7) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(149403,0);
	RTSC_setBBWCET(149403);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask0Job8) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(149403,0);
	RTSC_setBBWCET(149403);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask0Job9) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(149403,0);
	RTSC_setBBWCET(149403);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask0Job10) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(149403,0);
	RTSC_setBBWCET(149403);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job1) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(77936,0);
	RTSC_setBBWCET(77936);


	atomic_store(&Task1_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job2) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(77936,0);
	RTSC_setBBWCET(77936);


	atomic_store(&Task1_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job3) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(77936,0);
	RTSC_setBBWCET(77936);


	atomic_store(&Task1_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job4) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(77936,0);
	RTSC_setBBWCET(77936);


	atomic_store(&Task1_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job5) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(77936,0);
	RTSC_setBBWCET(77936);


	atomic_store(&Task1_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job6) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(77936,0);
	RTSC_setBBWCET(77936);


	atomic_store(&Task1_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job7) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(77936,0);
	RTSC_setBBWCET(77936);


	atomic_store(&Task1_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job8) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(77936,0);
	RTSC_setBBWCET(77936);


	atomic_store(&Task1_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job9) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(77936,0);
	RTSC_setBBWCET(77936);


	atomic_store(&Task1_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job10) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(77936,0);
	RTSC_setBBWCET(77936);


	atomic_store(&Task1_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask10Job1) {



	data Chain_0;

	Chain_0 = atomic_load(&Task9_Chain_0);

	loop_for(113939,0);
	RTSC_setBBWCET(113939);


	atomic_store(&Task10_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask11Job1) {





	loop_for(145950,0);
	RTSC_setBBWCET(145950);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask12Job1) {



	data Chain_0;

	Chain_0 = atomic_load(&Task10_Chain_0);

	loop_for(106246,0);
	RTSC_setBBWCET(106246);


	atomic_store(&Task12_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask13Job1) {



	data Chain_0;

	Chain_0 = atomic_load(&Task7_Chain_0);

	loop_for(146973,0);
	RTSC_setBBWCET(146973);


	logDataAge(0,1, time_to_longNS(time_diff(Chain_0.ts, get_time())));

	RTSC_setBBWCET(0);

}


Subtask(TaskTask13Job2) {



	data Chain_0;

	Chain_0 = atomic_load(&Task7_Chain_0);

	loop_for(146973,0);
	RTSC_setBBWCET(146973);


	logDataAge(0,2, time_to_longNS(time_diff(Chain_0.ts, get_time())));

	RTSC_setBBWCET(0);

}


Subtask(TaskTask13Job3) {



	data Chain_0;

	Chain_0 = atomic_load(&Task7_Chain_0);

	loop_for(146973,0);
	RTSC_setBBWCET(146973);


	logDataAge(0,3, time_to_longNS(time_diff(Chain_0.ts, get_time())));

	RTSC_setBBWCET(0);

}


Subtask(TaskTask13Job4) {



	data Chain_0;

	Chain_0 = atomic_load(&Task7_Chain_0);

	loop_for(146973,0);
	RTSC_setBBWCET(146973);


	logDataAge(0,4, time_to_longNS(time_diff(Chain_0.ts, get_time())));

	RTSC_setBBWCET(0);

}


Subtask(TaskTask13Job5) {



	data Chain_0;

	Chain_0 = atomic_load(&Task7_Chain_0);

	loop_for(146973,0);
	RTSC_setBBWCET(146973);


	logDataAge(0,5, time_to_longNS(time_diff(Chain_0.ts, get_time())));

	RTSC_setBBWCET(0);

}


Subtask(TaskTask2Job1) {



	data Chain_0;

	Chain_0 = atomic_load(&Task1_Chain_0);

	loop_for(118868,0);
	RTSC_setBBWCET(118868);


	atomic_store(&Task2_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask2Job2) {



	data Chain_0;

	Chain_0 = atomic_load(&Task1_Chain_0);

	loop_for(118868,0);
	RTSC_setBBWCET(118868);


	atomic_store(&Task2_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask2Job3) {



	data Chain_0;

	Chain_0 = atomic_load(&Task1_Chain_0);

	loop_for(118868,0);
	RTSC_setBBWCET(118868);


	atomic_store(&Task2_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask2Job4) {



	data Chain_0;

	Chain_0 = atomic_load(&Task1_Chain_0);

	loop_for(118868,0);
	RTSC_setBBWCET(118868);


	atomic_store(&Task2_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask2Job5) {



	data Chain_0;

	Chain_0 = atomic_load(&Task1_Chain_0);

	loop_for(118868,0);
	RTSC_setBBWCET(118868);


	atomic_store(&Task2_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask2Job6) {



	data Chain_0;

	Chain_0 = atomic_load(&Task1_Chain_0);

	loop_for(118868,0);
	RTSC_setBBWCET(118868);


	atomic_store(&Task2_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask2Job7) {



	data Chain_0;

	Chain_0 = atomic_load(&Task1_Chain_0);

	loop_for(118868,0);
	RTSC_setBBWCET(118868);


	atomic_store(&Task2_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask2Job8) {



	data Chain_0;

	Chain_0 = atomic_load(&Task1_Chain_0);

	loop_for(118868,0);
	RTSC_setBBWCET(118868);


	atomic_store(&Task2_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask2Job9) {



	data Chain_0;

	Chain_0 = atomic_load(&Task1_Chain_0);

	loop_for(118868,0);
	RTSC_setBBWCET(118868);


	atomic_store(&Task2_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask2Job10) {



	data Chain_0;

	Chain_0 = atomic_load(&Task1_Chain_0);

	loop_for(118868,0);
	RTSC_setBBWCET(118868);


	atomic_store(&Task2_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask3Job1) {



	data Chain_0;

	Chain_0 = atomic_load(&Task2_Chain_0);

	loop_for(130233,0);
	RTSC_setBBWCET(130233);


	atomic_store(&Task3_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask3Job2) {



	data Chain_0;

	Chain_0 = atomic_load(&Task2_Chain_0);

	loop_for(130233,0);
	RTSC_setBBWCET(130233);


	atomic_store(&Task3_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask3Job3) {



	data Chain_0;

	Chain_0 = atomic_load(&Task2_Chain_0);

	loop_for(130233,0);
	RTSC_setBBWCET(130233);


	atomic_store(&Task3_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask3Job4) {



	data Chain_0;

	Chain_0 = atomic_load(&Task2_Chain_0);

	loop_for(130233,0);
	RTSC_setBBWCET(130233);


	atomic_store(&Task3_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask3Job5) {



	data Chain_0;

	Chain_0 = atomic_load(&Task2_Chain_0);

	loop_for(130233,0);
	RTSC_setBBWCET(130233);


	atomic_store(&Task3_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask3Job6) {



	data Chain_0;

	Chain_0 = atomic_load(&Task2_Chain_0);

	loop_for(130233,0);
	RTSC_setBBWCET(130233);


	atomic_store(&Task3_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask3Job7) {



	data Chain_0;

	Chain_0 = atomic_load(&Task2_Chain_0);

	loop_for(130233,0);
	RTSC_setBBWCET(130233);


	atomic_store(&Task3_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask3Job8) {



	data Chain_0;

	Chain_0 = atomic_load(&Task2_Chain_0);

	loop_for(130233,0);
	RTSC_setBBWCET(130233);


	atomic_store(&Task3_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask3Job9) {



	data Chain_0;

	Chain_0 = atomic_load(&Task2_Chain_0);

	loop_for(130233,0);
	RTSC_setBBWCET(130233);


	atomic_store(&Task3_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask3Job10) {



	data Chain_0;

	Chain_0 = atomic_load(&Task2_Chain_0);

	loop_for(130233,0);
	RTSC_setBBWCET(130233);


	atomic_store(&Task3_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job1) {





	loop_for(143670,0);
	RTSC_setBBWCET(143670);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job2) {





	loop_for(143670,0);
	RTSC_setBBWCET(143670);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job3) {





	loop_for(143670,0);
	RTSC_setBBWCET(143670);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job4) {





	loop_for(143670,0);
	RTSC_setBBWCET(143670);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job5) {





	loop_for(143670,0);
	RTSC_setBBWCET(143670);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask5Job1) {



	data Chain_0;

	Chain_0 = atomic_load(&Task12_Chain_0);

	loop_for(112709,0);
	RTSC_setBBWCET(112709);


	atomic_store(&Task5_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask5Job2) {



	data Chain_0;

	Chain_0 = atomic_load(&Task12_Chain_0);

	loop_for(112709,0);
	RTSC_setBBWCET(112709);


	atomic_store(&Task5_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask5Job3) {



	data Chain_0;

	Chain_0 = atomic_load(&Task12_Chain_0);

	loop_for(112709,0);
	RTSC_setBBWCET(112709);


	atomic_store(&Task5_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask5Job4) {



	data Chain_0;

	Chain_0 = atomic_load(&Task12_Chain_0);

	loop_for(112709,0);
	RTSC_setBBWCET(112709);


	atomic_store(&Task5_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask5Job5) {



	data Chain_0;

	Chain_0 = atomic_load(&Task12_Chain_0);

	loop_for(112709,0);
	RTSC_setBBWCET(112709);


	atomic_store(&Task5_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job1) {



	data Chain_0;

	Chain_0 = atomic_load(&Task5_Chain_0);

	loop_for(52356,0);
	RTSC_setBBWCET(52356);


	atomic_store(&Task6_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job2) {



	data Chain_0;

	Chain_0 = atomic_load(&Task5_Chain_0);

	loop_for(52356,0);
	RTSC_setBBWCET(52356);


	atomic_store(&Task6_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job3) {



	data Chain_0;

	Chain_0 = atomic_load(&Task5_Chain_0);

	loop_for(52356,0);
	RTSC_setBBWCET(52356);


	atomic_store(&Task6_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job4) {



	data Chain_0;

	Chain_0 = atomic_load(&Task5_Chain_0);

	loop_for(52356,0);
	RTSC_setBBWCET(52356);


	atomic_store(&Task6_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job5) {



	data Chain_0;

	Chain_0 = atomic_load(&Task5_Chain_0);

	loop_for(52356,0);
	RTSC_setBBWCET(52356);


	atomic_store(&Task6_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job1) {



	data Chain_0;

	Chain_0 = atomic_load(&Task6_Chain_0);

	loop_for(71649,0);
	RTSC_setBBWCET(71649);


	atomic_store(&Task7_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job2) {



	data Chain_0;

	Chain_0 = atomic_load(&Task6_Chain_0);

	loop_for(71649,0);
	RTSC_setBBWCET(71649);


	atomic_store(&Task7_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job3) {



	data Chain_0;

	Chain_0 = atomic_load(&Task6_Chain_0);

	loop_for(71649,0);
	RTSC_setBBWCET(71649);


	atomic_store(&Task7_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job4) {



	data Chain_0;

	Chain_0 = atomic_load(&Task6_Chain_0);

	loop_for(71649,0);
	RTSC_setBBWCET(71649);


	atomic_store(&Task7_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job5) {



	data Chain_0;

	Chain_0 = atomic_load(&Task6_Chain_0);

	loop_for(71649,0);
	RTSC_setBBWCET(71649);


	atomic_store(&Task7_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job1) {



	data Chain_0;

	Chain_0 = atomic_load(&Task3_Chain_0);

	loop_for(91138,0);
	RTSC_setBBWCET(91138);


	atomic_store(&Task8_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask9Job1) {



	data Chain_0;

	Chain_0 = atomic_load(&Task8_Chain_0);

	loop_for(69999,0);
	RTSC_setBBWCET(69999);


	atomic_store(&Task9_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


