#include "csystem.h"
#include "rtsc_annotate.h"

#include <stdatomic.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include <time.h>
#include <unistd.h>

DeclareSubtask(TaskTask0Job1);
DeclareSubtask(TaskTask0Job2);
DeclareSubtask(TaskTask0Job3);
DeclareSubtask(TaskTask0Job4);
DeclareSubtask(TaskTask0Job5);
DeclareSubtask(TaskTask0Job6);
DeclareSubtask(TaskTask0Job7);
DeclareSubtask(TaskTask0Job8);
DeclareSubtask(TaskTask0Job9);
DeclareSubtask(TaskTask0Job10);
DeclareSubtask(TaskTask1Job1);
DeclareSubtask(TaskTask1Job2);
DeclareSubtask(TaskTask1Job3);
DeclareSubtask(TaskTask1Job4);
DeclareSubtask(TaskTask1Job5);
DeclareSubtask(TaskTask1Job6);
DeclareSubtask(TaskTask1Job7);
DeclareSubtask(TaskTask1Job8);
DeclareSubtask(TaskTask1Job9);
DeclareSubtask(TaskTask1Job10);
DeclareSubtask(TaskTask10Job1);
DeclareSubtask(TaskTask11Job1);
DeclareSubtask(TaskTask12Job1);
DeclareSubtask(TaskTask13Job1);
DeclareSubtask(TaskTask14Job1);
DeclareSubtask(TaskTask15Job1);
DeclareSubtask(TaskTask15Job2);
DeclareSubtask(TaskTask15Job3);
DeclareSubtask(TaskTask15Job4);
DeclareSubtask(TaskTask15Job5);
DeclareSubtask(TaskTask16Job1);
DeclareSubtask(TaskTask16Job2);
DeclareSubtask(TaskTask16Job3);
DeclareSubtask(TaskTask16Job4);
DeclareSubtask(TaskTask16Job5);
DeclareSubtask(TaskTask16Job6);
DeclareSubtask(TaskTask16Job7);
DeclareSubtask(TaskTask16Job8);
DeclareSubtask(TaskTask16Job9);
DeclareSubtask(TaskTask16Job10);
DeclareSubtask(TaskTask2Job1);
DeclareSubtask(TaskTask2Job2);
DeclareSubtask(TaskTask2Job3);
DeclareSubtask(TaskTask2Job4);
DeclareSubtask(TaskTask2Job5);
DeclareSubtask(TaskTask2Job6);
DeclareSubtask(TaskTask2Job7);
DeclareSubtask(TaskTask2Job8);
DeclareSubtask(TaskTask2Job9);
DeclareSubtask(TaskTask2Job10);
DeclareSubtask(TaskTask3Job1);
DeclareSubtask(TaskTask3Job2);
DeclareSubtask(TaskTask3Job3);
DeclareSubtask(TaskTask3Job4);
DeclareSubtask(TaskTask3Job5);
DeclareSubtask(TaskTask3Job6);
DeclareSubtask(TaskTask3Job7);
DeclareSubtask(TaskTask3Job8);
DeclareSubtask(TaskTask3Job9);
DeclareSubtask(TaskTask3Job10);
DeclareSubtask(TaskTask4Job1);
DeclareSubtask(TaskTask4Job2);
DeclareSubtask(TaskTask4Job3);
DeclareSubtask(TaskTask4Job4);
DeclareSubtask(TaskTask4Job5);
DeclareSubtask(TaskTask4Job6);
DeclareSubtask(TaskTask4Job7);
DeclareSubtask(TaskTask4Job8);
DeclareSubtask(TaskTask4Job9);
DeclareSubtask(TaskTask4Job10);
DeclareSubtask(TaskTask5Job1);
DeclareSubtask(TaskTask5Job2);
DeclareSubtask(TaskTask5Job3);
DeclareSubtask(TaskTask5Job4);
DeclareSubtask(TaskTask5Job5);
DeclareSubtask(TaskTask6Job1);
DeclareSubtask(TaskTask6Job2);
DeclareSubtask(TaskTask6Job3);
DeclareSubtask(TaskTask6Job4);
DeclareSubtask(TaskTask6Job5);
DeclareSubtask(TaskTask7Job1);
DeclareSubtask(TaskTask7Job2);
DeclareSubtask(TaskTask7Job3);
DeclareSubtask(TaskTask7Job4);
DeclareSubtask(TaskTask7Job5);
DeclareSubtask(TaskTask8Job1);
DeclareSubtask(TaskTask8Job2);
DeclareSubtask(TaskTask8Job3);
DeclareSubtask(TaskTask8Job4);
DeclareSubtask(TaskTask8Job5);
DeclareSubtask(TaskTask9Job1);
DeclareSubtask(TaskTask9Job2);
DeclareSubtask(TaskTask9Job3);
DeclareSubtask(TaskTask9Job4);
DeclareSubtask(TaskTask9Job5);



DeclareEvent(TaskTask10Job1TaskTask11Job1Event);
DeclareEvent(TaskTask11Job1TaskTask12Job1Event);
DeclareEvent(TaskTask12Job1TaskTask13Job1Event);
DeclareEvent(TaskTask13Job1TaskTask14Job1Event);
DeclareEvent(TaskTask14Job1TaskTask5Job2Event);
DeclareEvent(TaskTask5Job1TaskTask6Job1Event);
DeclareEvent(TaskTask5Job2TaskTask6Job2Event);
DeclareEvent(TaskTask5Job3TaskTask6Job3Event);
DeclareEvent(TaskTask5Job4TaskTask6Job4Event);
DeclareEvent(TaskTask5Job5TaskTask6Job5Event);
DeclareEvent(TaskTask6Job1TaskTask7Job1Event);
DeclareEvent(TaskTask6Job2TaskTask7Job2Event);
DeclareEvent(TaskTask6Job3TaskTask7Job3Event);
DeclareEvent(TaskTask6Job4TaskTask7Job4Event);
DeclareEvent(TaskTask6Job5TaskTask7Job5Event);
DeclareEvent(TaskTask7Job1TaskTask8Job1Event);
DeclareEvent(TaskTask7Job2TaskTask8Job2Event);
DeclareEvent(TaskTask7Job3TaskTask8Job3Event);
DeclareEvent(TaskTask7Job4TaskTask8Job4Event);
DeclareEvent(TaskTask7Job5TaskTask8Job5Event);
DeclareEvent(TaskTask8Job1TaskTask9Job1Event);
DeclareEvent(TaskTask8Job2TaskTask9Job2Event);
DeclareEvent(TaskTask8Job3TaskTask9Job3Event);
DeclareEvent(TaskTask8Job4TaskTask9Job4Event);
DeclareEvent(TaskTask8Job5TaskTask9Job5Event);


static const int NUMS = 4096;
static const int SECONDS_TO_NANO = 1000000000;
static const int MICROSECONDS_TO_NANO = 1000;
static int num[4096];
typedef struct timespec Time;

typedef struct data {
	uint64_t val;
	Time ts;
} data;
typedef _Atomic data atomic_data;

//Provided by data/SystemSupport/Litmus/misc/randomArray.cpp
double getNextRandom(void);

void logDataAge(unsigned int chain, unsigned int instance, unsigned long dataAge );

static atomic_data Task0_Chain_0;
static atomic_data Task1_Chain_0;
static atomic_data Task2_Chain_0;
static atomic_data Task4_Chain_0;
static atomic_data Task16_Chain_0;
static atomic_data Task10_Chain_0;
static atomic_data Task11_Chain_0;
static atomic_data Task12_Chain_0;
static atomic_data Task13_Chain_0;
static atomic_data Task14_Chain_0;
static atomic_data Task5_Chain_0;
static atomic_data Task6_Chain_0;
static atomic_data Task7_Chain_0;
static atomic_data Task8_Chain_0;
size_t getMaxChainInstances(void) {

	return 5;

}

static Time get_time() {
	RTSC_setBBWCET(0);
	static Time t;
	int err;
	err = clock_gettime(CLOCK_MONOTONIC, &t);
	if (err != 0) {
		RTSC_setBBWCET(0);
		perror("get_time():");
	}
	RTSC_setBBWCET(0);
	return t;
}

static inline Time time_diff(Time oldTime, Time time) {
	RTSC_setBBWCET(0);
	if (time.tv_nsec < oldTime.tv_nsec) {
		RTSC_setBBWCET(0);
		return (Time){
			.tv_sec = time.tv_sec - 1 - oldTime.tv_sec,
			.tv_nsec = 1000000000UL + time.tv_nsec - oldTime.tv_nsec
		};
	}
	else {
		RTSC_setBBWCET(0);
		return (Time){
			.tv_sec = time.tv_sec - oldTime.tv_sec,
			.tv_nsec = time.tv_nsec - oldTime.tv_nsec
		};
	}
	RTSC_setBBWCET(0);
}
static long time_to_longNS(Time ts) {
	RTSC_setBBWCET(0);
	return (ts.tv_sec * SECONDS_TO_NANO + ts.tv_nsec);
}

static long cputime(void) {
	RTSC_setBBWCET(0);
	Time ts;
	int err;
	err = clock_gettime(CLOCK_THREAD_CPUTIME_ID, &ts);
	if (err != 0) {
		RTSC_setBBWCET(0);
		perror("cputime");
	}
	RTSC_setBBWCET(0);
	return (ts.tv_sec * SECONDS_TO_NANO + ts.tv_nsec);
}

static long wctime(void) {
	RTSC_setBBWCET(0);
	struct timeval tv;
	gettimeofday(&tv, NULL);
	return (tv.tv_sec * SECONDS_TO_NANO + tv.tv_usec * MICROSECONDS_TO_NANO);
}

static int loop_once(void) {
	RTSC_setBBWCET(0);
	int i;
	int j = 0;
	for (i = 0; i < NUMS; i++) {
		RTSC_setLoopCount(0);
		RTSC_setBBWCET(0);
		j += num[i]++;
		if (j > num[i]) {
			RTSC_setBBWCET(0);
			num[i] = (j / 2) + 1;
		}
	}
	RTSC_setBBWCET(0);
	return j;
}

static int loop_for(long exec_time, long emergency_exit) {
	RTSC_setBBWCET(0);
	long full_exec_time = exec_time;
	exec_time = getNextRandom() * exec_time;
	long last_loop = 0;
	int tmp = 0;

	long start = cputime();
	long now = start;

	while (now + 3 * last_loop < start + exec_time) {
		RTSC_setLoopCount(0);
		RTSC_setBBWCET(0);
		long loop_start = now;
		tmp += loop_once();
		now = cputime();
		last_loop = now - loop_start;
		if (emergency_exit && wctime() > emergency_exit) {
			RTSC_setBBWCET(0);
			fprintf(stderr, "!!! rtspin/%d emergency exit!\n", getpid());
			fprintf(stderr, "Something is seriously wrong! Do not ignore this.\n");
			break;
		}
	}
	RTSC_setBBWCET(0);
	logLoopFor(full_exec_time, exec_time, now - start);
	return tmp;
}

Subtask(TaskTask0Job1) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(96139,0);
	RTSC_setBBWCET(96139);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask0Job2) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(96139,0);
	RTSC_setBBWCET(96139);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask0Job3) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(96139,0);
	RTSC_setBBWCET(96139);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask0Job4) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(96139,0);
	RTSC_setBBWCET(96139);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask0Job5) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(96139,0);
	RTSC_setBBWCET(96139);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask0Job6) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(96139,0);
	RTSC_setBBWCET(96139);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask0Job7) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(96139,0);
	RTSC_setBBWCET(96139);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask0Job8) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(96139,0);
	RTSC_setBBWCET(96139);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask0Job9) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(96139,0);
	RTSC_setBBWCET(96139);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask0Job10) {



	data Chain_0;

	Chain_0.val = 1;
	Chain_0.ts = get_time();

	loop_for(96139,0);
	RTSC_setBBWCET(96139);


	atomic_store(&Task0_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job1) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(65023,0);
	RTSC_setBBWCET(65023);


	atomic_store(&Task1_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job2) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(65023,0);
	RTSC_setBBWCET(65023);


	atomic_store(&Task1_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job3) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(65023,0);
	RTSC_setBBWCET(65023);


	atomic_store(&Task1_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job4) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(65023,0);
	RTSC_setBBWCET(65023);


	atomic_store(&Task1_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job5) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(65023,0);
	RTSC_setBBWCET(65023);


	atomic_store(&Task1_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job6) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(65023,0);
	RTSC_setBBWCET(65023);


	atomic_store(&Task1_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job7) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(65023,0);
	RTSC_setBBWCET(65023);


	atomic_store(&Task1_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job8) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(65023,0);
	RTSC_setBBWCET(65023);


	atomic_store(&Task1_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job9) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(65023,0);
	RTSC_setBBWCET(65023);


	atomic_store(&Task1_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask1Job10) {



	data Chain_0;

	Chain_0 = atomic_load(&Task0_Chain_0);

	loop_for(65023,0);
	RTSC_setBBWCET(65023);


	atomic_store(&Task1_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask10Job1) {



	data Chain_0;

	Chain_0 = atomic_load(&Task16_Chain_0);

	loop_for(93048,0);
	RTSC_setBBWCET(93048);


	atomic_store(&Task10_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask10Job1TaskTask11Job1Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask11Job1) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask10Job1TaskTask11Job1Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task10_Chain_0);

	loop_for(81904,0);
	RTSC_setBBWCET(81904);


	atomic_store(&Task11_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask11Job1TaskTask12Job1Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask12Job1) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask11Job1TaskTask12Job1Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task11_Chain_0);

	loop_for(117754,0);
	RTSC_setBBWCET(117754);


	atomic_store(&Task12_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask12Job1TaskTask13Job1Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask13Job1) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask12Job1TaskTask13Job1Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task12_Chain_0);

	loop_for(81000,0);
	RTSC_setBBWCET(81000);


	atomic_store(&Task13_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask13Job1TaskTask14Job1Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask14Job1) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask13Job1TaskTask14Job1Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task13_Chain_0);

	loop_for(86031,0);
	RTSC_setBBWCET(86031);


	atomic_store(&Task14_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask14Job1TaskTask5Job2Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask15Job1) {





	loop_for(125118,0);
	RTSC_setBBWCET(125118);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask15Job2) {





	loop_for(125118,0);
	RTSC_setBBWCET(125118);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask15Job3) {





	loop_for(125118,0);
	RTSC_setBBWCET(125118);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask15Job4) {





	loop_for(125118,0);
	RTSC_setBBWCET(125118);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask15Job5) {





	loop_for(125118,0);
	RTSC_setBBWCET(125118);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask16Job1) {



	data Chain_0;

	Chain_0 = atomic_load(&Task4_Chain_0);

	loop_for(140600,0);
	RTSC_setBBWCET(140600);


	atomic_store(&Task16_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask16Job2) {



	data Chain_0;

	Chain_0 = atomic_load(&Task4_Chain_0);

	loop_for(140600,0);
	RTSC_setBBWCET(140600);


	atomic_store(&Task16_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask16Job3) {



	data Chain_0;

	Chain_0 = atomic_load(&Task4_Chain_0);

	loop_for(140600,0);
	RTSC_setBBWCET(140600);


	atomic_store(&Task16_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask16Job4) {



	data Chain_0;

	Chain_0 = atomic_load(&Task4_Chain_0);

	loop_for(140600,0);
	RTSC_setBBWCET(140600);


	atomic_store(&Task16_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask16Job5) {



	data Chain_0;

	Chain_0 = atomic_load(&Task4_Chain_0);

	loop_for(140600,0);
	RTSC_setBBWCET(140600);


	atomic_store(&Task16_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask16Job6) {



	data Chain_0;

	Chain_0 = atomic_load(&Task4_Chain_0);

	loop_for(140600,0);
	RTSC_setBBWCET(140600);


	atomic_store(&Task16_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask16Job7) {



	data Chain_0;

	Chain_0 = atomic_load(&Task4_Chain_0);

	loop_for(140600,0);
	RTSC_setBBWCET(140600);


	atomic_store(&Task16_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask16Job8) {



	data Chain_0;

	Chain_0 = atomic_load(&Task4_Chain_0);

	loop_for(140600,0);
	RTSC_setBBWCET(140600);


	atomic_store(&Task16_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask16Job9) {



	data Chain_0;

	Chain_0 = atomic_load(&Task4_Chain_0);

	loop_for(140600,0);
	RTSC_setBBWCET(140600);


	atomic_store(&Task16_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask16Job10) {



	data Chain_0;

	Chain_0 = atomic_load(&Task4_Chain_0);

	loop_for(140600,0);
	RTSC_setBBWCET(140600);


	atomic_store(&Task16_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask2Job1) {



	data Chain_0;

	Chain_0 = atomic_load(&Task1_Chain_0);

	loop_for(100849,0);
	RTSC_setBBWCET(100849);


	atomic_store(&Task2_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask2Job2) {



	data Chain_0;

	Chain_0 = atomic_load(&Task1_Chain_0);

	loop_for(100849,0);
	RTSC_setBBWCET(100849);


	atomic_store(&Task2_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask2Job3) {



	data Chain_0;

	Chain_0 = atomic_load(&Task1_Chain_0);

	loop_for(100849,0);
	RTSC_setBBWCET(100849);


	atomic_store(&Task2_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask2Job4) {



	data Chain_0;

	Chain_0 = atomic_load(&Task1_Chain_0);

	loop_for(100849,0);
	RTSC_setBBWCET(100849);


	atomic_store(&Task2_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask2Job5) {



	data Chain_0;

	Chain_0 = atomic_load(&Task1_Chain_0);

	loop_for(100849,0);
	RTSC_setBBWCET(100849);


	atomic_store(&Task2_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask2Job6) {



	data Chain_0;

	Chain_0 = atomic_load(&Task1_Chain_0);

	loop_for(100849,0);
	RTSC_setBBWCET(100849);


	atomic_store(&Task2_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask2Job7) {



	data Chain_0;

	Chain_0 = atomic_load(&Task1_Chain_0);

	loop_for(100849,0);
	RTSC_setBBWCET(100849);


	atomic_store(&Task2_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask2Job8) {



	data Chain_0;

	Chain_0 = atomic_load(&Task1_Chain_0);

	loop_for(100849,0);
	RTSC_setBBWCET(100849);


	atomic_store(&Task2_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask2Job9) {



	data Chain_0;

	Chain_0 = atomic_load(&Task1_Chain_0);

	loop_for(100849,0);
	RTSC_setBBWCET(100849);


	atomic_store(&Task2_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask2Job10) {



	data Chain_0;

	Chain_0 = atomic_load(&Task1_Chain_0);

	loop_for(100849,0);
	RTSC_setBBWCET(100849);


	atomic_store(&Task2_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask3Job1) {





	loop_for(86295,0);
	RTSC_setBBWCET(86295);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask3Job2) {





	loop_for(86295,0);
	RTSC_setBBWCET(86295);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask3Job3) {





	loop_for(86295,0);
	RTSC_setBBWCET(86295);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask3Job4) {





	loop_for(86295,0);
	RTSC_setBBWCET(86295);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask3Job5) {





	loop_for(86295,0);
	RTSC_setBBWCET(86295);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask3Job6) {





	loop_for(86295,0);
	RTSC_setBBWCET(86295);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask3Job7) {





	loop_for(86295,0);
	RTSC_setBBWCET(86295);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask3Job8) {





	loop_for(86295,0);
	RTSC_setBBWCET(86295);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask3Job9) {





	loop_for(86295,0);
	RTSC_setBBWCET(86295);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask3Job10) {





	loop_for(86295,0);
	RTSC_setBBWCET(86295);



	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job1) {



	data Chain_0;

	Chain_0 = atomic_load(&Task2_Chain_0);

	loop_for(142459,0);
	RTSC_setBBWCET(142459);


	atomic_store(&Task4_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job2) {



	data Chain_0;

	Chain_0 = atomic_load(&Task2_Chain_0);

	loop_for(142459,0);
	RTSC_setBBWCET(142459);


	atomic_store(&Task4_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job3) {



	data Chain_0;

	Chain_0 = atomic_load(&Task2_Chain_0);

	loop_for(142459,0);
	RTSC_setBBWCET(142459);


	atomic_store(&Task4_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job4) {



	data Chain_0;

	Chain_0 = atomic_load(&Task2_Chain_0);

	loop_for(142459,0);
	RTSC_setBBWCET(142459);


	atomic_store(&Task4_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job5) {



	data Chain_0;

	Chain_0 = atomic_load(&Task2_Chain_0);

	loop_for(142459,0);
	RTSC_setBBWCET(142459);


	atomic_store(&Task4_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job6) {



	data Chain_0;

	Chain_0 = atomic_load(&Task2_Chain_0);

	loop_for(142459,0);
	RTSC_setBBWCET(142459);


	atomic_store(&Task4_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job7) {



	data Chain_0;

	Chain_0 = atomic_load(&Task2_Chain_0);

	loop_for(142459,0);
	RTSC_setBBWCET(142459);


	atomic_store(&Task4_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job8) {



	data Chain_0;

	Chain_0 = atomic_load(&Task2_Chain_0);

	loop_for(142459,0);
	RTSC_setBBWCET(142459);


	atomic_store(&Task4_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job9) {



	data Chain_0;

	Chain_0 = atomic_load(&Task2_Chain_0);

	loop_for(142459,0);
	RTSC_setBBWCET(142459);


	atomic_store(&Task4_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask4Job10) {



	data Chain_0;

	Chain_0 = atomic_load(&Task2_Chain_0);

	loop_for(142459,0);
	RTSC_setBBWCET(142459);


	atomic_store(&Task4_Chain_0, Chain_0);

	RTSC_setBBWCET(0);

}


Subtask(TaskTask5Job1) {



	data Chain_0;

	Chain_0 = atomic_load(&Task14_Chain_0);

	loop_for(69726,0);
	RTSC_setBBWCET(69726);


	atomic_store(&Task5_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask5Job1TaskTask6Job1Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask5Job2) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask14Job1TaskTask5Job2Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task14_Chain_0);

	loop_for(69726,0);
	RTSC_setBBWCET(69726);


	atomic_store(&Task5_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask5Job2TaskTask6Job2Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask5Job3) {



	data Chain_0;

	Chain_0 = atomic_load(&Task14_Chain_0);

	loop_for(69726,0);
	RTSC_setBBWCET(69726);


	atomic_store(&Task5_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask5Job3TaskTask6Job3Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask5Job4) {



	data Chain_0;

	Chain_0 = atomic_load(&Task14_Chain_0);

	loop_for(69726,0);
	RTSC_setBBWCET(69726);


	atomic_store(&Task5_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask5Job4TaskTask6Job4Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask5Job5) {



	data Chain_0;

	Chain_0 = atomic_load(&Task14_Chain_0);

	loop_for(69726,0);
	RTSC_setBBWCET(69726);


	atomic_store(&Task5_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask5Job5TaskTask6Job5Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job1) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask5Job1TaskTask6Job1Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task5_Chain_0);

	loop_for(138918,0);
	RTSC_setBBWCET(138918);


	atomic_store(&Task6_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask6Job1TaskTask7Job1Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job2) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask5Job2TaskTask6Job2Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task5_Chain_0);

	loop_for(138918,0);
	RTSC_setBBWCET(138918);


	atomic_store(&Task6_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask6Job2TaskTask7Job2Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job3) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask5Job3TaskTask6Job3Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task5_Chain_0);

	loop_for(138918,0);
	RTSC_setBBWCET(138918);


	atomic_store(&Task6_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask6Job3TaskTask7Job3Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job4) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask5Job4TaskTask6Job4Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task5_Chain_0);

	loop_for(138918,0);
	RTSC_setBBWCET(138918);


	atomic_store(&Task6_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask6Job4TaskTask7Job4Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask6Job5) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask5Job5TaskTask6Job5Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task5_Chain_0);

	loop_for(138918,0);
	RTSC_setBBWCET(138918);


	atomic_store(&Task6_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask6Job5TaskTask7Job5Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job1) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask6Job1TaskTask7Job1Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task6_Chain_0);

	loop_for(125619,0);
	RTSC_setBBWCET(125619);


	atomic_store(&Task7_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask7Job1TaskTask8Job1Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job2) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask6Job2TaskTask7Job2Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task6_Chain_0);

	loop_for(125619,0);
	RTSC_setBBWCET(125619);


	atomic_store(&Task7_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask7Job2TaskTask8Job2Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job3) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask6Job3TaskTask7Job3Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task6_Chain_0);

	loop_for(125619,0);
	RTSC_setBBWCET(125619);


	atomic_store(&Task7_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask7Job3TaskTask8Job3Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job4) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask6Job4TaskTask7Job4Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task6_Chain_0);

	loop_for(125619,0);
	RTSC_setBBWCET(125619);


	atomic_store(&Task7_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask7Job4TaskTask8Job4Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask7Job5) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask6Job5TaskTask7Job5Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task6_Chain_0);

	loop_for(125619,0);
	RTSC_setBBWCET(125619);


	atomic_store(&Task7_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask7Job5TaskTask8Job5Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job1) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask7Job1TaskTask8Job1Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task7_Chain_0);

	loop_for(87828,0);
	RTSC_setBBWCET(87828);


	atomic_store(&Task8_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask8Job1TaskTask9Job1Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job2) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask7Job2TaskTask8Job2Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task7_Chain_0);

	loop_for(87828,0);
	RTSC_setBBWCET(87828);


	atomic_store(&Task8_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask8Job2TaskTask9Job2Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job3) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask7Job3TaskTask8Job3Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task7_Chain_0);

	loop_for(87828,0);
	RTSC_setBBWCET(87828);


	atomic_store(&Task8_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask8Job3TaskTask9Job3Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job4) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask7Job4TaskTask8Job4Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task7_Chain_0);

	loop_for(87828,0);
	RTSC_setBBWCET(87828);


	atomic_store(&Task8_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask8Job4TaskTask9Job4Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask8Job5) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask7Job5TaskTask8Job5Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task7_Chain_0);

	loop_for(87828,0);
	RTSC_setBBWCET(87828);


	atomic_store(&Task8_Chain_0, Chain_0);

	RTSC_setBBWCET(0);
	SIGNAL(TaskTask8Job5TaskTask9Job5Event);
	RTSC_setBBWCET(0);

}


Subtask(TaskTask9Job1) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask8Job1TaskTask9Job1Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task8_Chain_0);

	loop_for(89048,0);
	RTSC_setBBWCET(89048);


	logDataAge(0,1, time_to_longNS(time_diff(Chain_0.ts, get_time())));

	RTSC_setBBWCET(0);

}


Subtask(TaskTask9Job2) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask8Job2TaskTask9Job2Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task8_Chain_0);

	loop_for(89048,0);
	RTSC_setBBWCET(89048);


	logDataAge(0,2, time_to_longNS(time_diff(Chain_0.ts, get_time())));

	RTSC_setBBWCET(0);

}


Subtask(TaskTask9Job3) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask8Job3TaskTask9Job3Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task8_Chain_0);

	loop_for(89048,0);
	RTSC_setBBWCET(89048);


	logDataAge(0,3, time_to_longNS(time_diff(Chain_0.ts, get_time())));

	RTSC_setBBWCET(0);

}


Subtask(TaskTask9Job4) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask8Job4TaskTask9Job4Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task8_Chain_0);

	loop_for(89048,0);
	RTSC_setBBWCET(89048);


	logDataAge(0,4, time_to_longNS(time_diff(Chain_0.ts, get_time())));

	RTSC_setBBWCET(0);

}


Subtask(TaskTask9Job5) {


	RTSC_setBBWCET(0);
  WAITONE1(TaskTask8Job5TaskTask9Job5Event);

	data Chain_0;

	Chain_0 = atomic_load(&Task8_Chain_0);

	loop_for(89048,0);
	RTSC_setBBWCET(89048);


	logDataAge(0,5, time_to_longNS(time_diff(Chain_0.ts, get_time())));

	RTSC_setBBWCET(0);

}


